<template>
  <div class="app-container">
    <div class="search">
      <el-date-picker v-model="table.getdataListParm.parammaps.inputDatetime" class="inputDatetime filter-item" type="daterange" range-separator="至" start-placeholder="开始日期" end-placeholder="结束日期" style="width: 250px;" />
      <el-button class="el-icon-arrow-left elIconArrowLeft" @click="handleBefore" />
      <el-button class="el-icon-arrow-right elIconArrowRight" @click="handleNext" />
      <el-select v-model="table.getdataListParm.parammaps.providerid" filterable placeholder="请选择供应商" class="filter-item" style="width: 150px;" clearable>
        <el-option v-for="item in supplierList" :key="item.id" :label="item.providerName" :value="item.id" />
      </el-select>
      <el-button class="successBorder" @click="form_search">查询</el-button>
      <el-button class="successBorder" @click="handleRefresh">重置</el-button>
    </div>
    <div class="operation">
      <el-button v-if="isRoleEdit" class="success" icon="el-icon-plus" @click="handleCreate">新增合同</el-button>
      <el-upload style="float: right;" :headers="headers" :data="uploadData" :action="uploadExcelUrl" :show-file-list="false" :before-upload="beforeImport" :on-success="handleImportSuccess">
        <el-button v-if="isRoleEdit" class="import" icon="el-icon-download" style="float: right;">导入</el-button>
      </el-upload>
      <el-dropdown style="float: right;margin-right: 10px;">
        <el-button class="export" icon="el-icon-upload2">导出</el-button>
        <el-dropdown-menu slot="dropdown">
          <el-dropdown-item @click.native="handleExport(1)">导出模板</el-dropdown-item>
          <el-dropdown-item @click.native="handleExport(2)">导出数据</el-dropdown-item>
        </el-dropdown-menu>
      </el-dropdown>
    </div>
    <div class="table">
      <el-table
        :key="table.tableKey"
        v-loading="table.listLoading"
        element-loading-text="给我一点时间"
        :data="table.list"
        border
        fit
        highlight-current-row
        style="width: 100%;"
        :row-style="rowStyle"
        :cell-style="cellStyle"
        class="elTable table-fixed"
        :max-height="myHeight"
      >
        <el-table-column label="序号" align="center" type="index" width="50px">
          <template slot-scope="scope">
            <span>{{ scope.$index + (table.pageNum-1) * table.pageSize + 1 }}</span>
          </template>
        </el-table-column>
        <el-table-column label="合同编号" min-width="130px" align="center">
          <template slot-scope="scope">
            <span>{{ scope.row.contractcode }}</span>
          </template>
        </el-table-column>
        <el-table-column label="供应商" min-width="130px" align="center">
          <template slot-scope="scope">
            <span>{{ scope.row.providername }}</span>
          </template>
        </el-table-column>
        <el-table-column label="录入日期" min-width="110px" align="center">
          <template slot-scope="scope">
            <span>{{ scope.row.operatetime }}</span>
          </template>
        </el-table-column>
        <el-table-column label="启用" min-width="110px" align="center">
          <template slot-scope="scope">
            <el-switch v-model="scope.row.enable" disabled active-color="#13ce66" inactive-color="#ff4949" :active-value="1" :inactive-value="0" />
          </template>
        </el-table-column>
        <el-table-column label="操作" align="center" width="100" class-name="small-padding fixed-width" fixed="right">
          <template slot-scope="{row}">
            <el-button class="miniSuccess" icon="el-icon-search" @click="form_see(row)" />
            <span v-if="isRoleEdit" class="centerSpan">|</span>
            <el-button v-if="isRoleEdit" class="miniSuccess" icon="el-icon-edit-outline" @click="handleUpdate(row)" />
            <span v-if="isRoleEdit" class="centerSpan">|</span>
            <el-button v-if="isRoleEdit" class="miniDanger" icon="el-icon-delete" @click="handleRowDelete(row)" />
          </template>
        </el-table-column>
      </el-table>
      <pagination v-show="table.total>=0" :total="table.total" :page.sync="table.getdataListParm.offset" :limit.sync="table.getdataListParm.pagecount" @pagination="getList" />
    </div>

    <!-- 新增 -->
    <el-dialog :fullscreen="dialogFull" :visible.sync="create.dialogFormVisible" :close-on-click-modal="false" width="90%">
      <template slot="title">
        <div class="avue-crud__dialog__header">
          <span class="el-dialog__title">
            <span style="display:inline-block;width:3px;height:20px;margin-right:5px; float: left;margin-top:2px" />
            {{ textMap[create.dialogStatus] }}
          </span>
          <div class="avue-crud__dialog__menu" @click="dialogFull? dialogFull=false: dialogFull=true">
            <svg-icon v-if="dialogFull" icon-class="exit-fullscreen" />
            <svg-icon v-else icon-class="fullscreen" />
          </div>
        </div>
      </template>
      <div class="app-add">
        <el-form ref="createTemp" :rules="create.rules" :model="create.createTemp" label-position="right" label-width="160px" style="width: 90%;margin:0 auto">
          <el-row>
            <el-col :span="8">
              <el-form-item label="合同编号:" prop="contractcode">
                <el-input ref="contractcode" v-model="create.createTemp.contractcode" class="filter-item" placeholder="合同编号" type="text" :disabled="create.dialogStatus !== 'create'" />
              </el-form-item>
            </el-col>
            <el-col :span="8">
              <el-form-item label="供应商:" prop="providerid">
                <el-select v-model="create.createTemp.providerid" filterable placeholder="请选择供应商" class="filter-item" style="width: 100%;" :disabled="create.dialogStatus !== 'create'" @change="changeSupplier">
                  <el-option v-for="item in supplierList" :key="item.id" :label="item.providerName" :value="item.id" />
                </el-select>
              </el-form-item>
            </el-col>
            <el-col :span="8">
              <el-form-item label="录入日期:" prop="operatetime">
                <el-date-picker v-model="create.createTemp.operatetime" class="filter-item" type="date" placeholder="录入日期" :disabled="create.dialogStatus==='see'" :clearable="false" />
              </el-form-item>
            </el-col>
          </el-row>
          <el-row>
            <el-col :span="8">
              <el-form-item label="添加饲料:" prop="feedid">
                <el-select v-model="create.createTemp.feedid" filterable placeholder="请选择饲料" class="filter-item" style="width: 100%;" :disabled="create.dialogStatus==='see'" @change="changeFeedNameAdd">
                  <el-option v-for="item in feedNameAddList" :key="item.id" :label="item.fname" :value="item.id" />
                </el-select>
              </el-form-item>
            </el-col>
            <el-col :span="8">
              <el-form-item label="是否启用:" prop="enable">
                <el-switch v-model="create.createTemp.enable" :disabled="create.dialogStatus==='see'" active-color="#13ce66" inactive-color="#ff4949" :active-value="1" :inactive-value="0" />
              </el-form-item>
            </el-col>
          </el-row>
        </el-form>
        <el-table
          :key="create.tableKey"
          v-loading="create.listLoading"
          element-loading-text="给我一点时间"
          :data="create.list"
          border
          fit
          highlight-current-row
          style="width: 100%;margin-bottom: 50px;"
          :row-style="rowStyle"
          :cell-style="cellStyle"
          class="elTable table-fixed"
        >
          <el-table-column label="饲料名称" min-width="130px" align="center">
            <template slot-scope="scope">
              <span>{{ scope.row.feedname }}</span>
            </template>
          </el-table-column>
          <el-table-column label="饲料价格" min-width="130px" align="center">
            <template slot-scope="scope">
              <el-input v-if="create.dialogStatus !=='see'" ref="input" v-model="scope.row.price" type="number" :step="0.01" placeholder="最多两位小数" style="width:80%;padding:10px 0;" />
              <span v-else> {{ scope.row.price }}</span>
            </template>
          </el-table-column>
          <el-table-column v-if="create.dialogStatus !=='see'" label="操作" align="center" width="50" class-name="small-padding fixed-width" fixed="right">
            <template slot-scope="{row}">
              <el-button class="miniDanger" icon="el-icon-delete" @click="handleFeedDelete(row)" />
            </template>
          </el-table-column>
        </el-table>
        <div slot="footer" class="dialog-footer">
          <el-button v-if="create.dialogStatus == 'see'" class="cancelClose cancelClose1" @click="create.dialogFormVisible = false; ">关闭</el-button>
          <el-button v-if="create.dialogStatus !== 'see'" class="cancelClose" @click="create.dialogFormVisible = false; ">关闭</el-button>
          <el-button v-if="create.dialogStatus !== 'see'" class="save" :disabled="isokDisable" @click="create.dialogStatus==='create'?createData():updateData()">确认</el-button>
        </div>
      </div>
    </el-dialog>

  </div>
</template>

<script>
import { GetDataByName, GetDataByNames, checkButtons, ExecDataByConfig, failproccess } from '@/api/common'
import Pagination from '@/components/Pagination'
import { parseTime, json2excel } from '@/utils/index.js'
import { MessageBox } from 'element-ui'
import Cookies from 'js-cookie'
import axios from 'axios'
import { getToken } from '@/utils/auth'
export default {
  name: 'FeedContract',
  components: { Pagination },
  data() {
    return {
      dialogFull: false,
      isRoleEdit: [],
      requestParams: [
        { name: 'getProviderListEnable', offset: 0, pagecount: 0, parammaps: { pastureid: Cookies.get('pastureid') }},
        { name: 'getFeedListEnable', offset: 0, pagecount: 0, parammaps: { pastureid: Cookies.get('pastureid') }}
      ],
      supplierList: [], // 供应商
      feedNameAddList: [], // 饲料名称
      table: {
        getdataListParm: {
          name: 'getBigContractList',
          page: 1,
          offset: 1,
          pagecount: parseInt(Cookies.get('pageCount')),
          returntype: 'Map',
          parammaps: {
            pastureid: Cookies.get('pastureid'),
            inputDatetime: '',
            startTime: '',
            stopTime: ''
          }
        },
        tableKey: 0,
        list: [],
        total: 0,
        listLoading: true
      },
      textMap: {
        create: '新增合同',
        update: '编辑合同',
        see: '查看合同'
      },
      create: {
        dialogFormVisible: false,
        dialogStatus: '',
        createTemp: {
          pastureid: Cookies.get('pastureid'), 'providerid': '', 'providername': '', 'emp': Cookies.get('employename'), 'enable': 1, 'operatetime': parseTime(new Date(), '{y}-{m}-{d}')
        },
        rules: {
          contractcode: [{ type: 'string', required: true, message: '必填', trigger: 'blur' }],
          providerid: [{ type: 'string', required: true, message: '必填', trigger: 'blur' }]
        },
        getdataListParm: {
          name: 'getContractList',
          page: 1,
          offset: 1,
          pagecount: 10,
          returntype: 'Map',
          parammaps: {}
        },
        listLoading: false,
        tableKey: 0,
        list: []
      },
      requestParam: {},
      download: {
        getdataListParm: {
          name: 'getBigContractList',
          page: 1,
          offset: 1,
          pagecount: 0,
          returntype: 'Map',
          parammaps: {
            pastureid: Cookies.get('pastureid'),
            inputDatetime: '',
            startTime: '',
            stopTime: ''
          }
        },
        list: []
      },
      isokDisable: false,
      rowStyle: { maxHeight: 30 + 'px', height: 30 + 'px' },
      cellStyle: { padding: 0 + 'px' },
      myHeight:document.documentElement.clientHeight - 85- 150 - 45
    }
  },
  computed: {
    // 设置请求头
    headers() {
      return {
        token: getToken()
      }
    },
    uploadData() {
      return {
        name: 'checkFeed,checkProvider,insertBigContractUpload,insertContractupload',
        importParams: '合同编号,供应商,饲料名称,饲料价格（元）,录入日期',
        sheetname: 'Sheet1',
        // 登录牧场
        pastureid: Cookies.get('pastureid'),
        // 日期参数
        dateParams: '录入日期',
        // 必填参数
        requiredParams: '合同编号,供应商,饲料名称,饲料价格（元）',
        // 为数值的参数
        numParams: '饲料价格（元）'
      }
    },
    // 设置上传地址
    uploadExcelUrl() {
      return Cookies.get('url') + 'authdata/ImportExcel'
    }
  },
  created() {
    this.getButtons()
    this.getDownList()
    this.getList()
  },

  methods: {
    getButtons() {
      const Edit = 'FeedContract'
      const isRoleEdit = checkButtons(JSON.parse(sessionStorage.getItem('buttons')), Edit)
      this.isRoleEdit = isRoleEdit
    },
    getDownList() {
      GetDataByNames(this.requestParams).then(response => {
        this.supplierList = response.data.getProviderListEnable.list
        this.feedNameAddList = response.data.getFeedListEnable.list
      })
    },
    handleBefore() {
      if (this.table.getdataListParm.parammaps.inputDatetime !== '' && this.table.getdataListParm.parammaps.inputDatetime !== null) {
        var start = new Date(this.table.getdataListParm.parammaps.inputDatetime[0].setDate(this.table.getdataListParm.parammaps.inputDatetime[0].getDate() - 1))
        var stop = new Date(this.table.getdataListParm.parammaps.inputDatetime[1].setDate(this.table.getdataListParm.parammaps.inputDatetime[1].getDate() - 1))
        this.table.getdataListParm.parammaps.inputDatetime.length = 0
        this.table.getdataListParm.parammaps.inputDatetime.push(start, stop)
        this.table.getdataListParm.parammaps.startTime = parseTime(start, '{y}-{m}-{d}')
        this.table.getdataListParm.parammaps.stopTime = parseTime(stop, '{y}-{m}-{d}')
        this.$forceUpdate()
        this.getList()
      }
    },
    handleNext() {
      if (this.table.getdataListParm.parammaps.inputDatetime !== '' && this.table.getdataListParm.parammaps.inputDatetime !== null) {
        var start = new Date(this.table.getdataListParm.parammaps.inputDatetime[0].setDate(this.table.getdataListParm.parammaps.inputDatetime[0].getDate() + 1))
        var stop = new Date(this.table.getdataListParm.parammaps.inputDatetime[1].setDate(this.table.getdataListParm.parammaps.inputDatetime[1].getDate() + 1))
        this.table.getdataListParm.parammaps.inputDatetime.length = 0
        this.table.getdataListParm.parammaps.inputDatetime.push(start, stop)
        this.table.getdataListParm.parammaps.startTime = parseTime(start, '{y}-{m}-{d}')
        this.table.getdataListParm.parammaps.stopTime = parseTime(stop, '{y}-{m}-{d}')
        this.$forceUpdate()
      }
    },
    getList() {
      this.table.listLoading = true
      GetDataByName(this.table.getdataListParm).then(response => {
        console.log('table数据', response.data.list)
        if (response.data.list !== null) {
          this.table.list = response.data.list
          this.table.pageNum = response.data.pageNum
          this.table.pageSize = response.data.pageSize
        } else {
          this.table.list = []
        }
        this.table.total = response.data.total
        setTimeout(() => {
          this.table.listLoading = false
        }, 100)
      })
    },
    form_search() {
      if (this.table.getdataListParm.parammaps.inputDatetime !== '' && this.table.getdataListParm.parammaps.inputDatetime !== null) {
        this.table.getdataListParm.parammaps.startTime = parseTime(this.table.getdataListParm.parammaps.inputDatetime[0], '{y}-{m}-{d}')
        this.table.getdataListParm.parammaps.stopTime = parseTime(this.table.getdataListParm.parammaps.inputDatetime[1], '{y}-{m}-{d}')
      } else {
        this.table.getdataListParm.parammaps.inputDatetime = ''
        this.table.getdataListParm.parammaps.startTime = ''
        this.table.getdataListParm.parammaps.stopTime = ''
      }
      this.table.getdataListParm.offset = 1
      this.getList()
    },
    handleRefresh() {
      this.table.getdataListParm.offset = 1
      this.table.getdataListParm.parammaps.inputDatetime = ''
      this.table.getdataListParm.parammaps.startTime = ''
      this.table.getdataListParm.parammaps.stopTime = ''
      this.table.getdataListParm.parammaps.providerid = ''
      this.getList()
    },

    resetCreateTemp() {
      this.create.createTemp = {
        pastureid: Cookies.get('pastureid'), 'providerid': '', 'providername': '', 'emp': Cookies.get('employename'), 'enable': 1, 'operatetime': parseTime(new Date(), '{y}-{m}-{d}')
      }
      this.create.list = []
    },
    handleCreate() {
      console.log('点击了新增')
      this.resetCreateTemp()
      this.dialogFull = false
      this.create.dialogStatus = 'create'
      this.create.dialogFormVisible = true
    },
    // 供应商
    changeSupplier(item) {
      this.create.createTemp.providername = this.supplierList.find(obj => obj.id == item).providerName
    },
    // 新增饲料
    changeFeedNameAdd(item) {
      var obj = {}
      obj.feedid = item
      obj.feedname = this.feedNameAddList.find(obj => obj.id == item).fname
      obj.pastureid = this.feedNameAddList.find(obj => obj.id == item).pastureid
      obj.price = ''
      obj.myId = (new Date()).valueOf()
      for (let i = 0; i < this.create.list.length; i++) {
        if (this.create.list[i].feedid == item) {
          this.$message({ type: 'warning', message: '添加饲料不可重复', duration: 2000 })
          return false
        }
      }
      this.create.list.push(obj)
    },
    handleFeedDelete(row) {
      for (let i = 0; i < this.create.list.length; i++) {
        console.log(this.create.list[i])
        if (this.create.list[i].myId === row.myId) {
          var listAddIndex = this.create.list.indexOf(this.create.list[i])
        }
        if (listAddIndex > -1) {
          this.create.list.splice(listAddIndex, 1)
          return
        }
      }
    },

    createData() {
      console.log('点击了新增保存')
      this.$refs['createTemp'].validate(valid => {
        if (valid) {
          this.isokDisable = true
          setTimeout(() => {
            this.isokDisable = false
          }, 1000)
          console.log(this.create.list.length)
          if (this.create.list.length == 0) {
            this.$message({ type: 'warning', message: '请添加饲料', duration: 2000 })
            return false
          }
          const rulesPrice = /^\d+(\.\d{1,2})?$/
          for (let i = 0; i < this.create.list.length; i++) {
            if (this.create.list[i].price == '') {
              this.$message({ type: 'warning', message: '饲料价格不可为空', duration: 2000 })
              return false
            }
            if (!rulesPrice.test(parseFloat(this.create.list[i].price))) {
              this.$message({ type: 'warning', message: '饲料价格最多保留两位小数', duration: 2000 })
              return false
            }
          }
          this.create.createTemp.operatetime = parseTime(this.create.createTemp.operatetime, '{y}-{m}-{d}')
          this.requestParam.common = { 'returnmap': '0' }
          this.requestParam.data = []
          this.requestParam.data[0] = { 'name': 'insertBigContract', 'type': 'e', 'parammaps': {
            'pastureid': this.create.createTemp.pastureid,
            'contractcode': this.create.createTemp.contractcode,
            'providerid': this.create.createTemp.providerid,
            'providername': this.create.createTemp.providername,
            'emp': this.create.createTemp.emp,
            'enable': this.create.createTemp.enable,
            'operatetime': this.create.createTemp.operatetime
          }}
          this.requestParam.data[1] = { 'name': 'insertSpotList', 'resultmaps': { 'list': this.create.list }}
          this.requestParam.data[1].children = []
          this.requestParam.data[1].children[0] = { 'name': 'insertContract', 'type': 'e', 'parammaps': {
            pastureid: '@insertSpotList.pastureid',
            bigid: '@insertBigContract.LastInsertId',
            feedid: '@insertSpotList.feedid',
            feedname: '@insertSpotList.feedname',
            price: '@insertSpotList.price'
          }}
          ExecDataByConfig(this.requestParam).then(response => {
            if (response.msg == 'fail') {
              const contractcode = new RegExp("key 'contractcode'")
              if (contractcode.test(response.data)) {
                this.$message({ type: 'error', message: '该合同已存在，不可重复生成', duration: 2000 })
              } else {
                this.$notify({ title: '保存失败', message: response.data, type: 'warning', duration: 2000 })
              }
            } else {
              this.$notify({ title: '', message: '成功', type: 'success', duration: 2000 })
              this.create.dialogFormVisible = false
              this.getList()
            }
          })
        }
      })
    },
    handleUpdate(row) {
      console.log('点击了编辑')
      this.create.dialogStatus = 'update'
      this.dialogFull = false
      this.create.dialogFormVisible = true
      this.create.createTemp = Object.assign({}, row)
      this.create.getdataListParm.parammaps.pastureid = row.pastureid
      this.create.getdataListParm.parammaps.id = row.id
      this.getSeeList()
    },
    updateData() {
      console.log('点击了编辑保存')
      this.$refs['createTemp'].validate(valid => {
        if (valid) {
          this.isokDisable = true
          setTimeout(() => {
            this.isokDisable = false
          }, 1000)
          console.log(this.create.list.length)
          if (this.create.list.length == 0) {
            this.$message({ type: 'warning', message: '请添加饲料', duration: 2000 })
            return false
          }
          const rulesPrice = /^\d+(\.\d{1,2})?$/
          for (let i = 0; i < this.create.list.length; i++) {
            if (this.create.list[i].price == '') {
              this.$message({ type: 'warning', message: '饲料价格不可为空', duration: 2000 })
              return false
            }
            if (!rulesPrice.test(parseFloat(this.create.list[i].price))) {
              this.$message({ type: 'warning', message: '饲料价格最多保留两位小数', duration: 2000 })
              return false
            }
          }
          this.create.createTemp.operatetime = parseTime(this.create.createTemp.operatetime, '{y}-{m}-{d}')
          this.requestParam.common = { 'returnmap': '0' }
          this.requestParam.data = []
          this.requestParam.data[0] = { 'name': 'updateBigContract', 'type': 'e', 'parammaps': {
            'pastureid': this.create.createTemp.pastureid,
            'id': this.create.createTemp.id,
            'operatetime': this.create.createTemp.operatetime,
            'enable': this.create.createTemp.enable
          }}
          this.requestParam.data[1] = { 'name': 'deleteContract', 'type': 'e', 'parammaps': {
            'pastureid': this.create.createTemp.pastureid,
            'id': this.create.createTemp.id
          }}
          this.requestParam.data[2] = { 'name': 'insertSpotList', 'resultmaps': { 'list': this.create.list }}
          this.requestParam.data[2].children = []
          this.requestParam.data[2].children[0] = { 'name': 'insertContract', 'type': 'e', 'parammaps': {
            pastureid: '@insertSpotList.pastureid',
            bigid: this.create.createTemp.id,
            feedid: '@insertSpotList.feedid',
            feedname: '@insertSpotList.feedname',
            price: '@insertSpotList.price'
          }}
          ExecDataByConfig(this.requestParam).then(response => {
            if (response.msg === 'fail') {
              this.$notify({ title: '保存失败', message: response.data, type: 'warning', duration: 2000 })
            } else {
              this.$notify({ title: '', message: '成功', type: 'success', duration: 2000 })
              this.create.dialogFormVisible = false
              this.getList()
            }
          })
        }
      })
    },
    form_see(row) {
      console.log('点击了查看')
      this.dialogFull = false
      this.create.dialogStatus = 'see'
      this.create.dialogFormVisible = true
      this.create.createTemp = Object.assign({}, row)
      this.create.getdataListParm.parammaps.pastureid = row.pastureid
      this.create.getdataListParm.parammaps.id = row.id
      this.getSeeList()
    },
    getSeeList() {
      this.create.listLoading = true
      GetDataByName(this.create.getdataListParm).then(response => {
        console.log('查看table数据', response.data.list)
        if (response.data.list !== null) {
          this.create.list = response.data.list
        } else {
          this.create.list = []
        }
        setTimeout(() => {
          this.create.listLoading = false
        }, 100)
      })
    },

    handleRowDelete(row) {
      MessageBox.confirm('是否确认删除此信息?', {
        confirmButtonText: '确认', cancelButtonText: '取消', type: 'warning'
      }).then(() => {
        console.log('点击了删除')
        this.requestParam.common = { 'returnmap': '0' }
        this.requestParam.data = []
        this.requestParam.data[0] = { 'name': 'deleteBigContract', 'type': 'e', 'parammaps': {
          'pastureid': row.pastureid,
          'id': row.id
        }}
        this.requestParam.data[1] = { 'name': 'deleteContract', 'type': 'e', 'parammaps': {
          'pastureid': row.pastureid,
          'id': row.id
        }}
        ExecDataByConfig(this.requestParam).then(response => {
          if (response.msg === 'fail') {
            this.$notify({ title: '保存失败', message: response.data, type: 'warning', duration: 2000 })
          } else {
            this.$notify({ title: '', message: '成功', type: 'success', duration: 2000 })
            this.getList()
          }
        })
      }).catch(() => {
        this.$message({ type: 'info', message: '已取消删除' })
      })
    },
    handleExport(item) {
      if (item == 1) {
        console.log('点击了导出模板')
        const requestParam = this.requestParam
        const url = Cookies.get('url') + 'file/导入导出模板/库存管理/饲料合同导入模板.xlsx' // 请求下载文件的地址
        console.log(url)
        axios({
          method: 'GET',
          url: url,
          data: requestParam,
          headers: { token: getToken(), optname: 'insertcustomdoc' },
          responseType: 'blob'
        }).then(res => {
          if (!res) return
          this.percentage = 99
          setTimeout(() => {
            this.isPercentage = false
          }, 2000)
          const blob = new Blob([res.data], {
            type: 'application/octet-stream;charset=utf-8'
          })
          const url = window.URL.createObjectURL(blob)
          const aLink = document.createElement('a')
          aLink.style.display = 'none'
          aLink.href = url
          const docname = '饲料合同导入模板.xlsx'
          aLink.setAttribute('download', docname) // 下载的文件
          document.body.appendChild(aLink)
          aLink.click()
          document.body.removeChild(aLink)
          window.URL.revokeObjectURL(url)
        })
      } else {
        console.log('点击了导出数据')
        this.download.getdataListParm.name = 'DownloadContractList'
        this.download.getdataListParm.parammaps = this.table.getdataListParm.parammaps
        if (this.download.getdataListParm.parammaps.inputDatetime !== '' && this.download.getdataListParm.parammaps.inputDatetime !== null) {
          this.download.getdataListParm.parammaps.startTime = parseTime(this.download.getdataListParm.parammaps.inputDatetime[0], '{y}-{m}-{d}')
          this.download.getdataListParm.parammaps.stopTime = parseTime(this.download.getdataListParm.parammaps.inputDatetime[1], '{y}-{m}-{d}')
        } else {
          this.download.getdataListParm.parammaps.inputDatetime = ''
          this.download.getdataListParm.parammaps.startTime = ''
          this.download.getdataListParm.parammaps.stopTime = ''
        }
        GetDataByName(this.download.getdataListParm).then(response => {
          if (response.data.list !== null) {
            this.download.list = response.data.list
          } else {
            this.download.list = []
          }
          var excelDatas = [
            {
              tHeader: ['合同编号', '供应商', '饲料名称', '饲料价格（元）', '录入日期'],
              filterVal: ['contractcode', 'providername', 'feedname', 'price', 'operatetime'],
              tableDatas: this.download.list,
              sheetName: 'Sheet1'
            }
          ]
          json2excel(excelDatas, '饲料合同', true, 'xlsx')
        })
      }
    },

    beforeImport(file) {
      const isLt2M = file.size / 1024 / 1024 < 2
      if (!isLt2M) {
        this.$message.error('上传文件大小不能超过 2MB!')
      }
      return isLt2M
    },
    handleImportSuccess(res, file) {
      this.getList()
      if (res.msg === 'ok') {
        this.$message({ title: '成功', message: '导入成功:' + res.data.success + '条!', type: 'success', duration: 2000 })
        if (res.data.err_count > 0) {
          this.$notify({ title: '失败', message: '导入失败:' + res.data.err_count + '条!', type: 'danger', duration: 2000 })
           import('@/vendor/Export2Excel').then(excel => {
             const list1 = res.data.result
             const tHeader = [
               '合同编号', '供应商', '饲料名称', '饲料价格（元）', '录入日期', '错误信息'
             ]
             const filterVal = [
               '合同编号', '供应商', '饲料名称', '饲料价格（元）', '录入日期', 'error_msg'
             ]
             const data1 = this.formatJson(filterVal, list1)
             excel.export_json_to_excel({ header: tHeader, data: data1, filename: '合同管理导入报错信息', autoWidth: true, bookType: 'xlsx' })
           })
        }
      } else {
        this.$notify({ title: '失败', message: '上传失败', type: 'danger', duration: 2000 })
      }
    },
    formatJson(filterVal, jsonData) {
      return jsonData.map(v =>
        filterVal.map(j => {
          if (j === 'timestamp') {
            return parseTime(v[j])
          } else {
            return v[j]
          }
        })
      )
    }

  }
}
</script>
<style lang="scss" scoped>
  .search{margin-top:10px;}
  
</style>
<style>
  .inputDatetime .el-range-separator{ padding: 0; margin: 0 10px; }
</style>
